package galgeleg.android;

import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.app.Activity;

public class SpilAkt extends Activity implements OnClickListener {
  private Button nytSpil;
  int[] taster = { R.id.q, R.id.w, R.id.e, R.id.r, R.id.t, R.id.y, R.id.u, R.id.i, R.id.o, R.id.p, R.id.å,
                   R.id.a, R.id.s, R.id.d, R.id.f, R.id.g, R.id.h, R.id.j, R.id.k, R.id.l, R.id.æ, R.id.ø,
                   R.id.z, R.id.x, R.id.c, R.id.v, R.id.b, R.id.n, R.id.m };
  MediaPlayer lydVundet;
  MediaPlayer lydTabt;

  static Galgelogik spil = new Galgelogik();
  private MediaPlayer lydTast;

  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.spil_akt);
    lydVundet = MediaPlayer.create(this, R.raw.lyd_vundet);
    lydVundet.setVolume(1, 1);
    lydTabt = MediaPlayer.create(this, R.raw.lyd_tabt);
    lydTabt.setVolume(1, 1);
    lydTast = MediaPlayer.create(this, R.raw.lyd_tast);
    lydTast.setVolume(1, 1);
    nytSpil = (Button) findViewById(R.id.nytSpil);
    nytSpil.setOnClickListener(this);
    for (int id : taster) {
      Button tast = (Button) findViewById(id);
      tast.setOnClickListener(this);
    };
    opdaterSkærm();
  }


  @Override
  public void onDestroy() {
    super.onDestroy();
    lydTast.stop();
    lydTast.release();
    lydTabt.stop();
    lydTabt.release();
    lydVundet.stop();
    lydVundet.release();
  }

  
  private void opdaterSkærm() {
    ImageView galge = (ImageView) findViewById(R.id.imageView1);
    TextView synligtOrd = (TextView) findViewById(R.id.synligtOrd);
    TextView info = (TextView) findViewById(R.id.info);
    TextView brugteBogstaver = (TextView) findViewById(R.id.brugteBogstaver);
    info.setText("Gæt et bogstav");

    int forkerteBogstaver = spil.getAntalForkerteBogstaver();
    if (forkerteBogstaver == 0) galge.setImageResource(R.drawable.galge);
    if (forkerteBogstaver == 1) galge.setImageResource(R.drawable.forkert1);
    if (forkerteBogstaver == 2) galge.setImageResource(R.drawable.forkert2);
    if (forkerteBogstaver == 3) galge.setImageResource(R.drawable.forkert3);
    if (forkerteBogstaver == 4) galge.setImageResource(R.drawable.forkert4);
    if (forkerteBogstaver == 5) galge.setImageResource(R.drawable.forkert5);
    if (forkerteBogstaver == 6) galge.setImageResource(R.drawable.forkert6);

    if (spil.getBrugteBogstaver().size() > 0) {
      if (spil.erSidsteBogstavKorrekt()) info.setText("Sidste bogstav var korrekt");
      else info.setText("Sidste bogstav var forkert");
    }

    synligtOrd.setText(spil.getSynligtOrd());
    brugteBogstaver.setText(spil.getBrugteBogstaver().toString());

    if (spil.erSpilletSlut()) {
      if (spil.erSpilletVundet()) {
        info.setText("Du har vundet");
      }
      if (spil.erSpilletTabt()) {
        info.setText("Du har tabt, ordet var : " + spil.getOrdet());
      }
    }
  }

  public void onClick(View knappen) {
    if (knappen == nytSpil) {
      spil.nulstil();
      return;
    }

    if (spil.erSpilletSlut()) {
      return;
    }

    Button tast = (Button) knappen;
    String tastStr = tast.getText().toString();

    int brugtBogstaverFør = spil.getBrugteBogstaver().size();
    spil.gætBogstav(tastStr);
    int brugtBogstaverEfter = spil.getBrugteBogstaver().size();
    
    opdaterSkærm();

    // Spil en lyd hvis der er valgt et nyt bogstav
    if (brugtBogstaverEfter != brugtBogstaverFør) {
      if (spil.erSpilletSlut()) {
        if (spil.erSpilletVundet()) {
          lydVundet.start();
        }
        if (spil.erSpilletTabt()) {
          lydTabt.start();
        }
      } else {
        lydTast.start();
      }
    }
  }
}
